Index: /trunk/src/sys/arch/mips/mips/cpu_exec.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/cpu_exec.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/cpu_exec.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: cpu_exec.c,v 1.50.54.1.4.13 2010/02/01 04:16:19 matt Exp $	*/
+/*	$NetBSD: cpu_exec.c,v 1.50.54.1.4.15 2011/04/29 08:26:24 matt Exp $	*/
 
 /*
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: cpu_exec.c,v 1.50.54.1.4.13 2010/02/01 04:16:19 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: cpu_exec.c,v 1.50.54.1.4.15 2011/04/29 08:26:24 matt Exp $");
 
 #include "opt_compat_netbsd.h"
@@ -53,83 +53,21 @@
 #include <uvm/uvm_extern.h>
 
+#include <compat/common/compat_util.h>
+
 #ifdef EXEC_ECOFF
 #include <sys/exec_ecoff.h>
 #endif
 #include <sys/exec_elf.h>			/* mandatory */
-#ifdef COMPAT_09
-#include <machine/bsd-aout.h>
-#endif
 #include <machine/reg.h>
 #include <mips/regnum.h>			/* symbolic register indices */
+#include <mips/locore.h>
 
 #include <compat/common/compat_util.h>
 
 int	mips_elf_makecmds(struct lwp *, struct exec_package *);
-
-
-/*
- * cpu_exec_aout_makecmds():
- *	cpu-dependent a.out format hook for execve().
- *
- * Determine of the given exec package refers to something which we
- * understand and, if so, set up the vmcmds for it.
- *
- */
-int
-cpu_exec_aout_makecmds(l, epp)
-	struct lwp *l;
-	struct exec_package *epp;
-{
-	int error;
-
-	/* If COMPAT_09 is defined, allow loading of old-style 4.4bsd a.out
-	   executables. */
-#ifdef COMPAT_09
-	struct bsd_aouthdr *hdr = (struct bsd_aouthdr *)epp->ep_hdr;
-
-	/* Only handle paged files (laziness). */
-	if (hdr->a_magic != BSD_ZMAGIC)
-#endif
-	{
-		/* If that failed, try old NetBSD-1.1 elf format */
-		error = mips_elf_makecmds (l, epp);
-		return error;
-	}
-
-#ifdef COMPAT_09
-	error = vn_marktext(epp->ep_vp);
-	if (error)
-		return (error);
-
-	epp->ep_taddr = 0x1000;
-	epp->ep_entry = hdr->a_entry;
-	epp->ep_tsize = hdr->a_text;
-	epp->ep_daddr = epp->ep_taddr + hdr->a_text;
-	epp->ep_dsize = hdr->a_data + hdr->a_bss;
-
-	/* set up command for text segment */
-	NEW_VMCMD(&epp->ep_vmcmds, vmcmd_map_pagedvn, hdr->a_text,
-	    epp->ep_taddr, epp->ep_vp, 0, VM_PROT_READ|VM_PROT_EXECUTE);
-
-	/* set up command for data segment */
-	NEW_VMCMD(&epp->ep_vmcmds, vmcmd_map_pagedvn, hdr->a_data,
-	    epp->ep_daddr, epp->ep_vp, hdr->a_text,
-	    VM_PROT_READ|VM_PROT_WRITE|VM_PROT_EXECUTE);
-
-	/* set up command for bss segment */
-	NEW_VMCMD(&epp->ep_vmcmds, vmcmd_map_zero, hdr->a_bss,
-	    epp->ep_daddr + hdr->a_data, NULLVP, 0,
-	    VM_PROT_READ|VM_PROT_WRITE|VM_PROT_EXECUTE);
-
-	return (*epp->ep_esch->ep_setup_stack)(p, epp);
-#endif
-}
 
 #ifdef EXEC_ECOFF
 void
-cpu_exec_ecoff_setregs(l, epp, stack)
-	struct lwp *l;
-	struct exec_package *epp;
-	vaddr_t stack;
+cpu_exec_ecoff_setregs(struct lwp *l, struct exec_package *epp, vaddr_t stack)
 {
 	struct ecoff_exechdr *execp = (struct ecoff_exechdr *)epp->ep_hdr;
@@ -146,7 +84,5 @@
  */
 int
-cpu_exec_ecoff_probe(l, epp)
-	struct lwp *l;
-	struct exec_package *epp;
+cpu_exec_ecoff_probe(struct lwp *l, struct exec_package *epp)
 {
 
@@ -164,7 +100,5 @@
 
 int
-mips_elf_makecmds (l, epp)
-        struct lwp *l;
-        struct exec_package *epp;
+mips_elf_makecmds(struct lwp *l, struct exec_package *epp)
 {
 	Elf32_Ehdr *ex = (Elf32_Ehdr *)epp->ep_hdr;
@@ -347,5 +281,10 @@
 	case EF_MIPS_ARCH_32:
 	case EF_MIPS_ARCH_64:
-		if (!CPUISMIPSNN)
+		if (!CPUISMIPSNN && !CPUISMIPS32R2 && !CPUISMIPS64R2)
+			return ENOEXEC;
+		break;
+	case EF_MIPS_ARCH_32R2:
+	case EF_MIPS_ARCH_64R2:
+		if (!CPUISMIPS32R2 && !CPUISMIPS64R2)
 			return ENOEXEC;
 		break;
@@ -361,10 +300,12 @@
 		break;
 #endif
+#ifdef COMPAT_16
+	case 0:
+		*start_p = ELF32_LINK_ADDR;
+		/* FALLTHROUGH */
+#endif
 	case EF_MIPS_ABI_O32:
 		itp_suffix = "o32";
 		p->p_md.md_abi = _MIPS_BSD_API_O32;
-#ifdef COMPAT_16
-		*start_p = ELF32_LINK_ADDR;
-#endif
 		if (old_abi != p->p_md.md_abi)
 			printf("pid %d(%s): ABI set to O32 (e_flags=%#x)\n", p->p_pid, p->p_comm, eh->e_flags);
@@ -383,4 +324,107 @@
 	struct proc * const p = l->l_proc;
 	Elf32_Ehdr * const eh = eh0;
+
+	/*
+	 * Mark the type of CPU that the dump happened on.
+	 */
+	if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS64R2) {
+		eh->e_flags |= EF_MIPS_ARCH_64R2;
+	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS64) {
+		eh->e_flags |= EF_MIPS_ARCH_64;
+	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS32R2) {
+		eh->e_flags |= EF_MIPS_ARCH_32R2;
+	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS32) {
+		eh->e_flags |= EF_MIPS_ARCH_32;
+	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS5) {
+		eh->e_flags |= EF_MIPS_ARCH_5;
+	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS4) {
+		eh->e_flags |= EF_MIPS_ARCH_4;
+	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS3) {
+		eh->e_flags |= EF_MIPS_ARCH_3;
+	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS2) {
+		eh->e_flags |= EF_MIPS_ARCH_2;
+	} else {
+		eh->e_flags |= EF_MIPS_ARCH_1;
+	}
+
+	switch (p->p_md.md_abi) {
+	case _MIPS_BSD_API_N32:
+		eh->e_flags |= EF_MIPS_ABI2;
+		break;
+	case _MIPS_BSD_API_O32:
+		eh->e_flags |=EF_MIPS_ABI_O32; 
+		break;
+	}
+}
+#endif
+
+#if EXEC_ELF64
+int
+mips_netbsd_elf64_probe(struct lwp *l, struct exec_package *epp, void *eh0,
+	char *itp, vaddr_t *start_p)
+{
+	struct proc * const p = l->l_proc;
+	const Elf64_Ehdr * const eh = eh0;
+	int old_abi = p->p_md.md_abi;
+	const char *itp_suffix = NULL;
+
+	switch (eh->e_flags & EF_MIPS_ARCH) {
+	case EF_MIPS_ARCH_1:
+		return ENOEXEC;
+	case EF_MIPS_ARCH_2:
+		if (mips_options.mips_cpu_arch < CPU_ARCH_MIPS2)
+			return ENOEXEC;
+		break;
+	case EF_MIPS_ARCH_3:
+		if (mips_options.mips_cpu_arch < CPU_ARCH_MIPS3)
+			return ENOEXEC;
+		break;
+	case EF_MIPS_ARCH_4:
+		if (mips_options.mips_cpu_arch < CPU_ARCH_MIPS4)
+			return ENOEXEC;
+		break;
+	case EF_MIPS_ARCH_5:
+		if (mips_options.mips_cpu_arch < CPU_ARCH_MIPS5)
+			return ENOEXEC;
+		break;
+	case EF_MIPS_ARCH_32:
+	case EF_MIPS_ARCH_32R2:
+		return ENOEXEC;
+	case EF_MIPS_ARCH_64:
+		if (!CPUISMIPS64 && !CPUISMIPS64R2)
+			return ENOEXEC;
+		break;
+	case EF_MIPS_ARCH_64R2:
+		if (!CPUISMIPS64R2)
+			return ENOEXEC;
+		break;
+	}
+
+	switch (eh->e_flags & (EF_MIPS_ABI|EF_MIPS_ABI2)) {
+	case 0:
+		itp_suffix = "64";
+		p->p_md.md_abi = _MIPS_BSD_API_N64;
+		if (old_abi != p->p_md.md_abi)
+			printf("pid %d(%s): ABI set to N64 (e_flags=%#x)\n", p->p_pid, p->p_comm, eh->e_flags);
+		break;
+	case EF_MIPS_ABI_O64:
+		itp_suffix = "o64";
+		p->p_md.md_abi = _MIPS_BSD_API_O64;
+		if (old_abi != p->p_md.md_abi)
+			printf("pid %d(%s): ABI set to O64 (e_flags=%#x)\n", p->p_pid, p->p_comm, eh->e_flags);
+		break;
+	default:
+		return ENOEXEC;
+	}
+
+	(void)compat_elf_check_interp(epp, itp, itp_suffix);
+	return 0;
+}
+
+void
+coredump_elf64_setup(struct lwp *l, void *eh0)
+{
+	struct proc * const p = l->l_proc;
+	Elf64_Ehdr * const eh = eh0;
 
 	/*
@@ -402,98 +446,4 @@
 		eh->e_flags |= EF_MIPS_ARCH_1;
 	}
-
-	switch (p->p_md.md_abi) {
-	case _MIPS_BSD_API_N32:
-		eh->e_flags |= EF_MIPS_ABI2;
-		break;
-	case _MIPS_BSD_API_O32:
-		eh->e_flags |=EF_MIPS_ABI_O32; 
-		break;
-	}
-}
-#endif
-
-#if EXEC_ELF64
-int
-mips_netbsd_elf64_probe(struct lwp *l, struct exec_package *epp, void *eh0,
-	char *itp, vaddr_t *start_p)
-{
-	struct proc * const p = l->l_proc;
-	const Elf64_Ehdr * const eh = eh0;
-	int old_abi = p->p_md.md_abi;
-	const char *itp_suffix = NULL;
-
-	switch (eh->e_flags & EF_MIPS_ARCH) {
-	case EF_MIPS_ARCH_1:
-		return ENOEXEC;
-	case EF_MIPS_ARCH_2:
-		if (mips_options.mips_cpu_arch < CPU_ARCH_MIPS2)
-			return ENOEXEC;
-		break;
-	case EF_MIPS_ARCH_3:
-		if (mips_options.mips_cpu_arch < CPU_ARCH_MIPS3)
-			return ENOEXEC;
-		break;
-	case EF_MIPS_ARCH_4:
-		if (mips_options.mips_cpu_arch < CPU_ARCH_MIPS4)
-			return ENOEXEC;
-		break;
-	case EF_MIPS_ARCH_5:
-		if (mips_options.mips_cpu_arch < CPU_ARCH_MIPS5)
-			return ENOEXEC;
-		break;
-	case EF_MIPS_ARCH_32:
-		return ENOEXEC;
-	case EF_MIPS_ARCH_64:
-		if (!CPUISMIPS64)
-			return ENOEXEC;
-		break;
-	}
-
-	switch (eh->e_flags & (EF_MIPS_ABI|EF_MIPS_ABI2)) {
-	case 0:
-		itp_suffix = "64";
-		p->p_md.md_abi = _MIPS_BSD_API_N64;
-		if (old_abi != p->p_md.md_abi)
-			printf("pid %d(%s): ABI set to N64 (e_flags=%#x)\n", p->p_pid, p->p_comm, eh->e_flags);
-		break;
-	case EF_MIPS_ABI_O64:
-		itp_suffix = "o64";
-		p->p_md.md_abi = _MIPS_BSD_API_O64;
-		if (old_abi != p->p_md.md_abi)
-			printf("pid %d(%s): ABI set to O64 (e_flags=%#x)\n", p->p_pid, p->p_comm, eh->e_flags);
-		break;
-	default:
-		return ENOEXEC;
-	}
-
-	(void)compat_elf_check_interp(epp, itp, itp_suffix);
-	return 0;
-}
-
-void
-coredump_elf64_setup(struct lwp *l, void *eh0)
-{
-	struct proc * const p = l->l_proc;
-	Elf64_Ehdr * const eh = eh0;
-
-	/*
-	 * Mark the type of CPU that the dump happened on.
-	 */
-	if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS64) {
-		eh->e_flags |= EF_MIPS_ARCH_64;
-	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS32) {
-		eh->e_flags |= EF_MIPS_ARCH_32;
-	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS5) {
-		eh->e_flags |= EF_MIPS_ARCH_5;
-	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS4) {
-		eh->e_flags |= EF_MIPS_ARCH_4;
-	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS3) {
-		eh->e_flags |= EF_MIPS_ARCH_3;
-	} else if (mips_options.mips_cpu_arch & CPU_ARCH_MIPS2) {
-		eh->e_flags |= EF_MIPS_ARCH_2;
-	} else {
-		eh->e_flags |= EF_MIPS_ARCH_1;
-	}
 	switch (p->p_md.md_abi) {
 	case _MIPS_BSD_API_N64:
Index: /trunk/src/sys/arch/mips/mips/cpu_subr.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/cpu_subr.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/cpu_subr.c	(revision 152)
@@ -29,10 +29,10 @@
 
 #include <sys/cdefs.h>
-
+__KERNEL_RCSID(0, "cpu_subr.c,v 1.1.2.17 2011/04/29 08:26:24 matt Exp");
+
+#include "opt_ddb.h"
 #include "opt_multiprocessor.h"
 #include "opt_cputype.h"
 #include "opt_sa.h"
-
-__KERNEL_RCSID(0, "$NetBSD: cpu_subr.c,v 1.1.2.8 2010/04/30 16:10:42 matt Exp $");
 
 #include <sys/param.h>
@@ -40,10 +40,11 @@
 #include <sys/intr.h>
 #include <sys/atomic.h>
+#include <sys/device.h>
 #include <sys/lwp.h>
 #include <sys/proc.h>
-#include <sys/user.h>
 #include <sys/ras.h>
 #include <sys/bitops.h>
 #include <sys/idle.h>
+#include <sys/xcall.h>
 #ifdef KERN_SA
 #include <sys/sa.h>
@@ -51,12 +52,22 @@
 #endif
 
-#include <uvm/uvm_extern.h>
+#include <uvm/uvm.h>
 
 #include <mips/locore.h>
 #include <mips/regnum.h>
+#include <mips/pcb.h>
 #include <mips/cache.h>
 #include <mips/frame.h>
 #include <mips/userret.h>
 #include <mips/pte.h>
+#include <mips/cpuset.h>
+
+#if defined(DDB) || defined(KGDB)
+#ifdef DDB 
+#include <mips/db_machdep.h>
+#include <ddb/db_command.h>
+#include <ddb/db_output.h>
+#endif
+#endif
 
 #ifndef TSAR
@@ -72,5 +83,8 @@
 #endif
 	.ci_tlb_info = &pmap_tlb0_info,
-	.ci_pmap_segbase = (void *)(MIPS_KSEG2_START + 0x1eadbeef),
+	.ci_pmap_seg0tab = (void *)(MIPS_KSEG2_START + 0x1eadbeef),
+#ifdef _LP64
+	.ci_pmap_segtab = (void *)(MIPS_KSEG2_START + 0x1eadbeef),
+#endif
 	.ci_cpl = IPL_HIGH,
 	.ci_tlb_slot = -1,
@@ -82,12 +96,18 @@
 #ifdef MULTIPROCESSOR
 
-volatile u_long cpus_running = 1;
-volatile u_long cpus_hatched = 1;
-volatile u_long cpus_paused = 0;
+volatile __cpuset_t cpus_running = 1;
+volatile __cpuset_t cpus_hatched = 1;
+volatile __cpuset_t cpus_paused = 0;
+volatile __cpuset_t cpus_resumed = 0;
+volatile __cpuset_t cpus_halted = 0;
+
+static int  cpu_ipi_wait(volatile __cpuset_t *, u_long);
+static void cpu_ipi_error(const char *, __cpuset_t, __cpuset_t);
 
 static struct cpu_info *cpu_info_last = &cpu_info_store;
 
 struct cpu_info *
-cpu_info_alloc(struct pmap_tlb_info *ti, u_int cpu_id)
+cpu_info_alloc(struct pmap_tlb_info *ti, cpuid_t cpu_id, cpuid_t cpu_package_id,
+	cpuid_t cpu_core_id, cpuid_t cpu_smt_id)
 {
 	vaddr_t cpu_info_offset = (vaddr_t)&cpu_info_store & PAGE_MASK; 
@@ -96,9 +116,9 @@
 
 	/*
-	* Grab a page from the first 256MB to use to store
+	* Grab a page from the first 512MB (mappable by KSEG0) to use to store
 	* exception vectors and cpu_info for this cpu.
 	*/
 	error = uvm_pglistalloc(PAGE_SIZE,
-	    0, 0x10000000,
+	    0, MIPS_KSEG1_START - MIPS_KSEG0_START,
 	    PAGE_SIZE, PAGE_SIZE, &pglist, 1, false);
 	if (error)
@@ -126,4 +146,7 @@
 
 	ci->ci_cpuid = cpu_id;
+	ci->ci_data.cpu_package_id = cpu_package_id;
+	ci->ci_data.cpu_core_id = cpu_core_id;
+	ci->ci_data.cpu_smt_id = cpu_smt_id;
 	ci->ci_cpu_freq = cpu_info_store.ci_cpu_freq;
 	ci->ci_cctr_freq = cpu_info_store.ci_cctr_freq;
@@ -131,4 +154,5 @@
         ci->ci_divisor_delay = cpu_info_store.ci_divisor_delay;
         ci->ci_divisor_recip = cpu_info_store.ci_divisor_recip;
+	ci->ci_cpuwatch_count = cpu_info_store.ci_cpuwatch_count;
 
 	/*
@@ -171,7 +195,31 @@
 #endif /* MULTIPROCESSOR */
 
+static void
+cpu_hwrena_setup(void)
+{
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	const int cp0flags = mips_options.mips_cpu->cpu_cp0flags;
+	if ((cp0flags & MIPS_CP0FL_USE) == 0)
+		return;
+
+	if (cp0flags & MIPS_CP0FL_HWRENA) {
+		mipsNN_cp0_hwrena_write(
+		    MIPS_HWRENA_UL
+		    |MIPS_HWRENA_CCRES
+		    |MIPS_HWRENA_CC
+		    |MIPS_HWRENA_SYNCI_STEP
+		    |MIPS_HWRENA_CPUNUM);
+		if (cp0flags & MIPS_CP0FL_USERLOCAL) {
+			mipsNN_cp0_userlocal_write(curlwp->l_private);
+		}
+	}
+#endif
+}
+
 void
 cpu_attach_common(device_t self, struct cpu_info *ci)
 {
+	const char * const xname = device_xname(self);
+
 	/*
 	 * Cross link cpu_info and its device together
@@ -181,10 +229,22 @@
 	KASSERT(ci->ci_idepth == 0);
 
-	evcnt_attach_dynamic(&ci->ci_count_compare_evcnt,
-		EVCNT_TYPE_INTR, NULL, device_xname(self),
-		"int 5 (clock)");
-	evcnt_attach_dynamic(&ci->ci_count_compare_missed_evcnt,
-		EVCNT_TYPE_INTR, NULL, device_xname(self),
-		"int 5 (clock) missed");
+	evcnt_attach_dynamic(&ci->ci_ev_count_compare,
+		EVCNT_TYPE_INTR, NULL, xname,
+		"intr 5 (clock)");
+	evcnt_attach_dynamic(&ci->ci_ev_count_compare_missed,
+		EVCNT_TYPE_INTR, NULL, xname,
+		"intr 5 (clock) missed");
+	evcnt_attach_dynamic(&ci->ci_ev_fpu_loads,
+		EVCNT_TYPE_MISC, NULL, xname,
+		"fpu loads");
+	evcnt_attach_dynamic(&ci->ci_ev_fpu_saves,
+		EVCNT_TYPE_MISC, NULL, xname,
+		"fpu saves");
+	evcnt_attach_dynamic(&ci->ci_ev_tlbmisses,
+		EVCNT_TYPE_TRAP, NULL, xname,
+		"tlb misses");
+
+	if (ci == &cpu_info_store)
+		pmap_tlb_info_evcnt_attach(ci->ci_tlb_info);
 
 #ifdef MULTIPROCESSOR
@@ -199,14 +259,14 @@
 	}
 	evcnt_attach_dynamic(&ci->ci_evcnt_synci_activate_rqst,
-	    EVCNT_TYPE_MISC, NULL, device_xname(self),
+	    EVCNT_TYPE_MISC, NULL, xname,
 	    "syncicache activate request");
 	evcnt_attach_dynamic(&ci->ci_evcnt_synci_deferred_rqst,
-	    EVCNT_TYPE_MISC, NULL, device_xname(self),
+	    EVCNT_TYPE_MISC, NULL, xname,
 	    "syncicache deferred request");
 	evcnt_attach_dynamic(&ci->ci_evcnt_synci_ipi_rqst,
-	    EVCNT_TYPE_MISC, NULL, device_xname(self),
+	    EVCNT_TYPE_MISC, NULL, xname,
 	    "syncicache ipi request");
 	evcnt_attach_dynamic(&ci->ci_evcnt_synci_onproc_rqst,
-	    EVCNT_TYPE_MISC, NULL, device_xname(self),
+	    EVCNT_TYPE_MISC, NULL, xname,
 	    "syncicache onproc request");
 
@@ -233,4 +293,8 @@
 
 	fpu_init();
+
+	pmap_tlb_info_evcnt_attach(&pmap_tlb0_info);
+
+	cpu_hwrena_setup();
 
 	/*
@@ -343,4 +407,7 @@
 	gr[_REG_EPC]   = tf->tf_regs[_R_PC];
 	gr[_REG_SR]    = tf->tf_regs[_R_SR];
+#ifdef __HAVE_CPU_LWP_SETPRIVATE
+	mcp->_mc_tlsbase = (intptr_t)l->l_private;
+#endif
 
 	if ((ras_pc = (intptr_t)ras_lookup(l->l_proc,
@@ -349,7 +416,10 @@
 
 	*flags |= _UC_CPU;
+#ifdef __HAVE_CPU_LWP_SETPRIVATE
+	*flags |= _UC_TLSBASE;
+#endif
 
 	/* Save floating point register context, if any. */
-	if (l->l_md.md_flags & MDP_FPUSED) {
+	if (fpu_used_p(l)) {
 		size_t fplen;
 		/*
@@ -357,5 +427,5 @@
 		 * context to the PCB first.
 		 */
-		fpusave_lwp(l);
+		fpu_save_lwp(l);
 
 		/*
@@ -372,5 +442,6 @@
 		}
 #endif
-		memcpy(&mcp->__fpregs, &l->l_addr->u_pcb.pcb_fpregs, fplen);
+		struct pcb * const pcb = lwp_getpcb(l);
+		memcpy(&mcp->__fpregs, &pcb->pcb_fpregs, fplen);
 		*flags |= _UC_FPU;
 	}
@@ -408,4 +479,11 @@
 	}
 
+#ifdef __HAVE_CPU_LWP_SETPRIVATE
+	/* Restore the private thread context */
+	if (flags & _UC_TLSBASE) {
+		lwp_setprivate(l, (void *)(intptr_t)mcp->_mc_tlsbase);
+	}
+#endif
+
 	/* Restore floating point register context, if any. */
 	if (flags & _UC_FPU) {
@@ -413,5 +491,6 @@
 
 		/* Disable the FPU contents. */
-		fpudiscard_lwp(l);
+		KASSERT(curlwp == l);
+		fpu_discard();
 
 #if !defined(__mips_o32)
@@ -428,5 +507,6 @@
 		 * proper size of fpreg when copying.
 		 */
-		memcpy(&l->l_addr->u_pcb.pcb_fpregs, &mcp->__fpregs, fplen);
+		struct pcb * const pcb = lwp_getpcb(l);
+		memcpy(&pcb->pcb_fpregs, &mcp->__fpregs, fplen);
 	}
 
@@ -504,6 +584,8 @@
 {
 	KASSERT(kpreempt_disabled());
+#ifdef __HAVE_FAST_SOFTINTS
 	KASSERT(lwp_locked(l, NULL));
-	KASSERT(l->l_stat == LSONPROC || l->l_stat == LSRUN);
+#endif
+	KASSERT(l->l_stat == LSONPROC || l->l_stat == LSRUN || l->l_stat == LSSTOP);
 
 	l->l_md.md_astpending = 1; 		/* force call to ast() */
@@ -535,21 +617,25 @@
         KASSERT(kpreempt_disabled());
 
-	if (where == 0) {
+#if 0
+	if (where == (intptr_t)-2) {
+		KASSERT(curcpu()->ci_mtx_count == 0);
 		/*
-		 * We are called from KPREEMPT_ENABLE().  If we are at IPL_NONE,
-		 * of course we can be preempted.  If we aren't, ask for a
-		 * softint so that kern_intr can call kpreempt.
+		 * We must be called via kern_intr (which already checks for
+		 * IPL_NONE so of course we call be preempted).
 		 */
-		if (s == IPL_NONE)
-			return true;
-		softint_trigger(SOFTINT_KPREEMPT);
-		return false;
-	}
-
-	/*
-	 * We must be called via kern_intr (which already checks for IPL_NONE
-	 * so of course we call be preempted).
-	 */
-	return true;
+		return true;
+	}
+	/*
+	 * We are called from KPREEMPT_ENABLE().  If we are at IPL_NONE,
+	 * of course we can be preempted.  If we aren't, ask for a
+	 * softint so that kern_intr can call kpreempt.
+	 */
+	if (s == IPL_NONE) {
+		KASSERT(curcpu()->ci_mtx_count == 0);
+		return true;
+	}
+	softint_trigger(SOFTINT_KPREEMPT);
+#endif
+	return false;
 }
 
@@ -582,4 +668,7 @@
 
 	if (!__predict_false(ci->ci_want_resched)) {
+#ifdef __HAVE_FAST_SOFTINTS
+		KASSERT(ci->ci_data.cpu_softints == 0);
+#endif
 		(*mach_idle)();
 	}
@@ -598,4 +687,30 @@
 #ifndef TSAR
 #ifdef MULTIPROCESSOR
+
+void
+cpu_broadcast_ipi(int tag)
+{
+	(void)cpu_multicast_ipi(
+		CPUSET_EXCEPT(cpus_running, cpu_index(curcpu())), tag);
+}
+
+void
+cpu_multicast_ipi(__cpuset_t cpuset, int tag)
+{
+	CPU_INFO_ITERATOR cii;
+	struct cpu_info *ci;
+
+	CPUSET_DEL(cpuset, cpu_index(curcpu()));
+	if (CPUSET_EMPTY_P(cpuset))
+		return;
+
+	for (CPU_INFO_FOREACH(cii, ci)) {
+		if (CPUSET_HAS_P(cpuset, cpu_index(ci))) {
+			CPUSET_DEL(cpuset, cpu_index(ci));
+			(void)cpu_send_ipi(ci, tag);
+		}
+	}
+}
+
 int
 cpu_send_ipi(struct cpu_info *ci, int tag)
@@ -605,9 +720,189 @@
 }
 
+static void
+cpu_ipi_error(const char *s, __cpuset_t succeeded, __cpuset_t expected)
+{
+	CPUSET_SUB(expected, succeeded);
+	if (!CPUSET_EMPTY_P(expected)) {
+		printf("Failed to %s:", s);
+		do {
+			int index = CPUSET_NEXT(expected);
+			CPUSET_DEL(expected, index);
+			printf(" cpu%d", index);
+		} while (!CPUSET_EMPTY_P(expected));
+		printf("\n");
+	}
+}
+
+static int
+cpu_ipi_wait(volatile __cpuset_t *watchset, u_long mask)
+{
+	u_long limit = curcpu()->ci_cpu_freq;	/* some finite amount of time */
+
+	while (limit--)
+		if (*watchset == mask)
+			return 0;		/* success */
+
+	return 1;				/* timed out */
+}
+
+/*
+ * Halt this cpu
+ */
+void
+cpu_halt(void)
+{
+	int index = cpu_index(curcpu());
+
+	printf("cpu%d: shutting down\n", index);
+	CPUSET_ADD(cpus_halted, index);
+	spl0();		/* allow interrupts e.g. further ipi ? */
+	for (;;) ;	/* spin */
+
+	/* NOTREACHED */
+}
+
+/*
+ * Halt all running cpus, excluding current cpu.
+ */
+void
+cpu_halt_others(void)
+{
+	__cpuset_t cpumask, cpuset;
+
+	CPUSET_ASSIGN(cpuset, cpus_running);
+	CPUSET_DEL(cpuset, cpu_index(curcpu()));
+	CPUSET_ASSIGN(cpumask, cpuset);
+	CPUSET_SUB(cpuset, cpus_halted);
+
+	if (CPUSET_EMPTY_P(cpuset))
+		return;
+
+	cpu_multicast_ipi(cpuset, IPI_HALT);
+	if (cpu_ipi_wait(&cpus_halted, cpumask))
+		cpu_ipi_error("halt", cpumask, cpus_halted);
+
+	/*
+	 * TBD
+	 * Depending on available firmware methods, other cpus will
+	 * either shut down themselfs, or spin and wait for us to
+	 * stop them.
+	 */
+}
+
+/*
+ * Pause this cpu
+ */
+void
+cpu_pause(struct reg *regsp)
+{
+	int s = splhigh();
+	int index = cpu_index(curcpu());
+
+	for (;;) {
+		CPUSET_ADD(cpus_paused, index);
+		do {
+			;
+		} while (CPUSET_HAS_P(cpus_paused, index));
+		CPUSET_ADD(cpus_resumed, index);
+
+#if defined(DDB)
+		if (ddb_running_on_this_cpu_p())
+			cpu_Debugger();
+		if (ddb_running_on_any_cpu_p())
+			continue;
+#endif
+		break;
+	}
+
+	splx(s);
+}
+
+/*
+ * Pause all running cpus, excluding current cpu.
+ */
+void
+cpu_pause_others(void)
+{
+	__cpuset_t cpuset;
+
+	CPUSET_ASSIGN(cpuset, cpus_running);
+	CPUSET_DEL(cpuset, cpu_index(curcpu()));
+
+	if (CPUSET_EMPTY_P(cpuset))
+		return;
+
+	cpu_multicast_ipi(cpuset, IPI_SUSPEND);
+	if (cpu_ipi_wait(&cpus_paused, cpuset))
+		cpu_ipi_error("pause", cpus_paused, cpuset);
+}
+
+/*
+ * Resume a single cpu
+ */
+void
+cpu_resume(int index)
+{
+	CPUSET_CLEAR(cpus_resumed);
+	CPUSET_DEL(cpus_paused, index);
+
+	if (cpu_ipi_wait(&cpus_resumed, CPUSET_SINGLE(index)))
+		cpu_ipi_error("resume", cpus_resumed, CPUSET_SINGLE(index));
+}
+
+/*
+ * Resume all paused cpus.
+ */
+void
+cpu_resume_others(void)
+{
+	__cpuset_t cpuset;
+
+	CPUSET_CLEAR(cpus_resumed);
+	CPUSET_ASSIGN(cpuset, cpus_paused);
+	CPUSET_CLEAR(cpus_paused);
+
+	/* CPUs awake on cpus_paused clear */
+	if (cpu_ipi_wait(&cpus_resumed, cpuset))
+		cpu_ipi_error("resume", cpus_resumed, cpuset);
+}
+
+int
+cpu_is_paused(int index)
+{
+
+	return CPUSET_HAS_P(cpus_paused, index);
+}
+
+#ifdef DDB
+void
+cpu_debug_dump(void)
+{
+	CPU_INFO_ITERATOR cii;
+	struct cpu_info *ci;
+	char running, hatched, paused, resumed, halted;
+
+	db_printf("CPU CPUID STATE CPUINFO            CPL INT MTX IPIS\n");
+	for (CPU_INFO_FOREACH(cii, ci)) {
+		hatched = (CPUSET_HAS_P(cpus_hatched, cpu_index(ci)) ? 'H' : '-');
+		running = (CPUSET_HAS_P(cpus_running, cpu_index(ci)) ? 'R' : '-');
+		paused  = (CPUSET_HAS_P(cpus_paused,  cpu_index(ci)) ? 'P' : '-');
+		resumed = (CPUSET_HAS_P(cpus_resumed, cpu_index(ci)) ? 'r' : '-');
+		halted  = (CPUSET_HAS_P(cpus_halted,  cpu_index(ci)) ? 'h' : '-');
+		db_printf("%3d 0x%03lx %c%c%c%c%c %p "
+			"%3d %3d %3d "
+			"0x%02" PRIx64 "/0x%02" PRIx64 "\n",
+			cpu_index(ci), ci->ci_cpuid,
+			running, hatched, paused, resumed, halted,
+			ci, ci->ci_cpl, ci->ci_idepth, ci->ci_mtx_count,
+			ci->ci_active_ipis, ci->ci_request_ipis);
+	}
+}
+#endif
+
 void
 cpu_hatch(struct cpu_info *ci)
 {
 	struct pmap_tlb_info * const ti = ci->ci_tlb_info;
-	const u_long cpu_mask = 1L << cpu_index(ci);
 
 	/*
@@ -620,4 +915,9 @@
 
 	/*
+	 * Setup HWRENA and USERLOCAL COP0 registers (MIPSxxR2).
+	 */
+	cpu_hwrena_setup();
+
+	/*
 	 * If we are using register zero relative addressing to access cpu_info
 	 * in the exception vectors, enter that mapping into TLB now.
@@ -644,10 +944,10 @@
 	 * Announce we are hatched
 	 */
-	atomic_or_ulong(&cpus_hatched, cpu_mask);
+	CPUSET_ADD(cpus_hatched, cpu_index(ci));
 
 	/*
 	 * Now wait to be set free!
 	 */
-	while ((cpus_running & cpu_mask) == 0) {
+	while (! CPUSET_HAS_P(cpus_running, cpu_index(ci))) {
 		/* spin, spin, spin */
 	}
@@ -663,4 +963,10 @@
 
 	/*
+	 * Let this CPU do its own post-running initialization
+	 * (for things that have to be done on the local CPU).
+	 */
+	(*mips_locoresw.lsw_cpu_run)(ci);
+
+	/*
 	 * Now turn on interrupts.
 	 */
@@ -679,5 +985,4 @@
 	     ci != NULL;
 	     ci = ci->ci_next) {
-		const u_long cpu_mask = 1L << cpu_index(ci);
 		KASSERT(!CPU_IS_PRIMARY(ci));
 		KASSERT(ci->ci_data.cpu_idlelwp);
@@ -686,10 +991,10 @@
 		 * Skip this CPU if it didn't sucessfully hatch.
 		 */
-		if ((cpus_hatched & cpu_mask) == 0)
+		if (! CPUSET_HAS_P(cpus_hatched, cpu_index(ci)))
 			continue;
 
 		ci->ci_data.cpu_cc_skew = mips3_cp0_count_read();
 		atomic_or_ulong(&ci->ci_flags, CPUF_RUNNING);
-		atomic_or_ulong(&cpus_running, cpu_mask);
+		CPUSET_ADD(cpus_running, cpu_index(ci));
 	}
 }
@@ -703,2 +1008,169 @@
 	(*mips_locoresw.lsw_cpu_offline_md)();
 }
+
+#ifdef _LP64
+void
+cpu_vmspace_exec(lwp_t *l, vaddr_t start, vaddr_t end)
+{
+	/*
+	 * We need to turn on/off UX so that copyout/copyin will work
+	 * well before setreg gets called.
+	 */
+	uint32_t sr = mips_cp0_status_read();
+	if (end != (uint32_t) end) {
+		mips_cp0_status_write(sr | MIPS3_SR_UX);
+	} else {
+		mips_cp0_status_write(sr & ~MIPS3_SR_UX);
+	}
+}
+#endif
+
+#ifdef __HAVE_CPU_LWP_SETPRIVATE
+int
+cpu_lwp_setprivate(lwp_t *l, void *v)
+{
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	if (l == curlwp
+	    && (mips_options.mips_cpu->cpu_cp0flags & MIPS_CP0FL_USERLOCAL)) {
+		mipsNN_cp0_userlocal_write(v);
+	}
+#endif
+	return 0;
+}
+#endif
+
+
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+
+#if (CPUWATCH_MAX != 8)
+# error CPUWATCH_MAX
+#endif
+
+/*
+ * cpuwatch_discover - determine how many COP0 watchpoints this CPU supports
+ */
+u_int
+cpuwatch_discover(void)
+{
+	int i;
+
+	for (i=0; i < CPUWATCH_MAX; i++) {
+		uint32_t watchhi = mipsNN_cp0_watchhi_read(i);
+		if ((watchhi & __BIT(31)) == 0)	/* test 'M' bit */
+			break;
+	}
+	return i + 1;
+}
+
+void
+cpuwatch_free(cpu_watchpoint_t *cwp)
+{
+#ifdef DIAGNOSTIC
+	struct cpu_info * const ci = curcpu();
+	KASSERT(cwp >= &ci->ci_cpuwatch_tab[0] &&
+		cwp <= &ci->ci_cpuwatch_tab[ci->ci_cpuwatch_count-1]);
+#endif
+	cwp->cw_mode = 0;
+	cwp->cw_asid = 0;
+	cwp->cw_addr = 0;
+	cpuwatch_clr(cwp);
+}
+
+/*
+ * cpuwatch_alloc
+ * 	find an empty slot
+ *	no locking for the table since it is CPU private
+ */
+cpu_watchpoint_t *
+cpuwatch_alloc(void)
+{
+	struct cpu_info * const ci = curcpu();
+	cpu_watchpoint_t *cwp;
+
+	for (int i=0; i < ci->ci_cpuwatch_count; i++) {
+		cwp = &ci->ci_cpuwatch_tab[i];
+		if ((cwp->cw_mode & CPUWATCH_RWX) == 0)
+			return cwp;
+	}
+	return NULL;
+}
+
+
+void
+cpuwatch_set_all(void)
+{
+	struct cpu_info * const ci = curcpu();
+	cpu_watchpoint_t *cwp;
+	int i;
+
+	for (i=0; i < ci->ci_cpuwatch_count; i++) {
+		cwp = &ci->ci_cpuwatch_tab[i];
+		if ((cwp->cw_mode & CPUWATCH_RWX) != 0)
+			cpuwatch_set(cwp);
+	}
+}
+
+void
+cpuwatch_clr_all(void)
+{
+	struct cpu_info * const ci = curcpu();
+	cpu_watchpoint_t *cwp;
+	int i;
+
+	for (i=0; i < ci->ci_cpuwatch_count; i++) {
+		cwp = &ci->ci_cpuwatch_tab[i];
+		if ((cwp->cw_mode & CPUWATCH_RWX) != 0)
+			cpuwatch_clr(cwp);
+	}
+}
+
+/*
+ * cpuwatch_set - establish a MIPS COP0 watchpoint
+ */
+void
+cpuwatch_set(cpu_watchpoint_t *cwp)
+{
+	struct cpu_info * const ci = curcpu();
+	uint32_t watchhi;
+	register_t watchlo;
+	int cwnum = cwp - &ci->ci_cpuwatch_tab[0];
+
+	KASSERT(cwp >= &ci->ci_cpuwatch_tab[0] &&
+		cwp <= &ci->ci_cpuwatch_tab[ci->ci_cpuwatch_count-1]);
+
+	watchlo = cwp->cw_addr;
+	if (cwp->cw_mode & CPUWATCH_WRITE)
+		watchlo |= __BIT(0);
+	if (cwp->cw_mode & CPUWATCH_READ)
+		watchlo |= __BIT(1);
+	if (cwp->cw_mode & CPUWATCH_EXEC)
+		watchlo |= __BIT(2);
+
+	if (cwp->cw_mode & CPUWATCH_ASID)
+		watchhi = cwp->cw_asid << 16;	/* addr qualified by asid */
+	else
+		watchhi = __BIT(30);		/* addr not qual. by asid (Global) */
+	if (cwp->cw_mode & CPUWATCH_MASK)
+		watchhi |= cwp->cw_mask;	/* set "dont care" addr match bits */
+
+	mipsNN_cp0_watchhi_write(cwnum, watchhi);
+	mipsNN_cp0_watchlo_write(cwnum, watchlo);
+}
+
+/*
+ * cpuwatch_clr - disestablish a MIPS COP0 watchpoint
+ */
+void
+cpuwatch_clr(cpu_watchpoint_t *cwp)
+{
+	struct cpu_info * const ci = curcpu();
+	int cwnum = cwp - &ci->ci_cpuwatch_tab[0];
+
+	KASSERT(cwp >= &ci->ci_cpuwatch_tab[0] &&
+		cwp <= &ci->ci_cpuwatch_tab[ci->ci_cpuwatch_count-1]);
+
+	mipsNN_cp0_watchhi_write(cwnum, 0);
+	mipsNN_cp0_watchlo_write(cwnum, 0);
+}
+
+#endif	/* (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
Index: /trunk/src/sys/arch/mips/mips/db_disasm.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/db_disasm.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/db_disasm.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: db_disasm.c,v 1.19.62.2 2009/11/14 21:52:08 matt Exp $	*/
+/*	$NetBSD: db_disasm.c,v 1.19.62.3 2011/04/29 08:26:24 matt Exp $	*/
 
 /*-
@@ -36,5 +36,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: db_disasm.c,v 1.19.62.2 2009/11/14 21:52:08 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: db_disasm.c,v 1.19.62.3 2011/04/29 08:26:24 matt Exp $");
 
 #include <sys/types.h>
@@ -135,9 +135,9 @@
 static const char * const c0_reg[32] = {
 	"index",    "random",   "tlblo0",  "tlblo1",
-	"context",  "pagemask", "wired",   "cp0r7",
+	"context",  "pagemask", "wired",   "hwrena",
 	"badvaddr", "count",    "tlbhi",   "compare",
 	"status",   "cause",    "epc",     "prid",
 	"config",   "lladdr",   "watchlo", "watchhi",
-	"xcontext", "cp0r21",   "cp0r22",  "debug",
+	"xcontext", "cp0r21",   "osscratch",  "debug",
 	"depc",     "perfcnt",  "ecc",     "cacheerr",
 	"taglo",    "taghi",    "errepc",  "desave"
@@ -398,4 +398,28 @@
 			break;
 
+		case OP_DMT:
+			db_printf("dmtc1\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_DMF:
+			db_printf("dmfc1\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_MTH:
+			db_printf("mthc1\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_MFH:
+			db_printf("mfhc1\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
 		default:
 			db_printf("%s.%s\tf%d,f%d,f%d",
@@ -403,4 +427,68 @@
 			    fmt_name[i.FRType.fmt],
 			    i.FRType.fd, i.FRType.fs, i.FRType.ft);
+		}
+		break;
+
+	case OP_COP2:
+		switch (i.RType.rs) {
+		case OP_BCx:
+		case OP_BCy:
+			db_printf("bc2%c\t",
+			    "ft"[i.RType.rt & COPz_BC_TF_MASK]);
+			goto pr_displ;
+
+		case OP_MT:
+			db_printf("mtc2\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_MF:
+			db_printf("mfc2\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_CT:
+			db_printf("ctc2\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_CF:
+			db_printf("cfc2\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_DMT:
+			db_printf("dmtc2\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_DMF:
+			db_printf("dmfc2\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_MTH:
+			db_printf("mthc2\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		case OP_MFH:
+			db_printf("mfhc2\t%s,f%d",
+			    reg_name[i.RType.rt],
+			    i.RType.rd);
+			break;
+
+		default:
+			db_printf("%s\t%s,%s,%d", op_name[i.IType.op],
+			    reg_name[i.IType.rt],
+			    reg_name[i.IType.rs],
+			    (short)i.IType.imm);
 		}
 		break;
